function Aref = Laplace_element_stiffness_matrix(FEM)
% generate element stiffness matrix A
% A{i,j} contains dim x dim matrix resuling from the integral of
% nabla phi_i otimes nabla phi_j 
% over the reference element

n = FEM.Ref.s;
Aref = cell(n);
d = FEM.Th.dim;
for i = 1:n
    dphi_i = FEM.Ref.dbaseval(:,:,i);
    Aref{i,i}=zeros(d);
    for l = 1:d
        for m = 1:d
          Aref{i,i}(l,m) = (dphi_i(l,:).*dphi_i(m,:))*FEM.Ref.intw;
        end
    end
    for j = (i+1):n
        dphi_j = FEM.Ref.dbaseval(:,:,j);
        Aref{i,j}=zeros(d);
        for l = 1:d
            for m = 1:d
              Aref{i,j}(l,m) = (dphi_i(l,:).*dphi_j(m,:))*FEM.Ref.intw;
            end
        end
        Aref{j,i} = Aref{i,j};
    end
end