function FEM=parameters

% geometry parameters
p.X = [0,1];
p.Y = [0,1];
% number of nodes in y direction
p.Ny = 10;
% number of nodes in x-direction per grain
p.Nx = 10;

% frequency of right hand side (integer)
p.nux = 1;
p.nuy = 1;
% exact solution
p.exact = @(x) sin(2*pi*p.nux*x(:,1)).*sin(2*pi*p.nuy*x(:,2));
% corresponding right hand side: - Laplacian of p.exact
p.f = @(x) 4*pi^2*(p.nux^2+p.nuy^2)*sin(2*pi*p.nux*x(:,1)).*sin(2*pi*p.nuy*x(:,2));
% corresponding Dirichlet data
p.g = @(x) p.exact(x);
FEM.parameters = p;
