function showsol(FEM)

p = FEM.parameters;
% gradient available?
gd = isfield(FEM.solution,'gradient');
if gd
  P = FEM.solution.gradient.P;
  G = FEM.solution.gradient.G;
  if isfield(FEM.solution.gradient,'show')
    gd = FEM.solution.gradient.show ~= 0;
  end
end

if isfield(FEM.solution,'finepatch');
    faces = FEM.solution.finepatch;
    u = FEM.solution.ufull;
    vertices = FEM.Vh.nodes;
else
    ncorn = size(FEM.Th.corners,1);
    u = FEM.solution.ufull(1:ncorn);
    faces = FEM.Th.elements;
    vertices = FEM.Th.corners;
end

patch('Faces',faces,'Vertices',[vertices u],'FaceVertexCData',u)
shading interp
if gd
  hold on
  N = sqrt(G(:,1).^2+G(:,2).^2);
  quiver(P(:,1),P(:,2),G(:,1)./N,G(:,2)./N);  
  hold off
end
% compute error if possible
if isfield(p,'exact')
  [err,pos] = max(abs(p.exact(vertices)-u));
  fprintf('maximal error %.2e at position (%.3f,%.3f)\n',err,vertices(pos,1),vertices(pos,2));
end