function [Z,U] = pmeasprod(X,W,y,w)
%Der Aufruf [Z,U] = pmeasprod(X,W,y,w) bildet das Produktma aus den durch (X,W) bzw.
%(y,w) definierten Punktmaen. Dabei ist (X,W) ein Punktma mit N d-dimensionalen Punkten 
%in X (Nxd Matrix) und N Gewichten W (Nx1) Matrix. Entsprechend ist (y,w)
%ein Punktma mit M 1-dimensionalen Punkten in y und M gewichten in w
%Das Ergebnis Z ist eine (N*m)x(d+1) Matrix.
if isempty(X)
    Z = y(:);
    U = w(:);
else
  d = size(X,2);
  N = size(X,1);
  M = length(y);

  Z = [repmat(X,M,1), reshape(repmat(reshape(y,1,M),N,1),N*M,1)];
  U = W*reshape(w,1,M);
  U = U(:);
end;